;;; This file contains the hint text for angela's experiment.

(in-package tutor)

(defparameter *angela-hints*
  '((evaluate 
     ;; expression
     ("Find a box with two numbers and an operator and click it."
      "Click the button labeled \"Evaluate\""
      "Click the little green box."
      ;; there's no . at the end so it won't wrap
      "Find the answer by evaluating the box above and enter it")
     ;; input box
     ("Find a box with just a number and click it."
      "Click the button labeled \"Evaluate\""
      "Click the little green box."
      "Enter the number from the top box.")
     ;; 0 * anything
     ("Find a box with 0 multiplied by a little box."
      "Click the button labeled \"Evaluate\"")
     ;; 0 + anything
     ("Find a box with 0 added to a little box."
      "Click the button labeled \"Evaluate\""))
    (invert
     ;; regular invert
     ("Find a bottom box with just a number and a box feeding into that box and click them."
      "Click the button labeled \"Invert\""
      "Click the green box."
      "Enter the number from the bottom box, then a new operator, which is the inverse of the operator from the box above, and then the number from the box above.")
     ;; special case
     ("Find a bottom box with just a number and a box feeding into that box and click them."
      "Click the button labeled \"Invert\""
      "Click the green box."
      "Enter the number from the box above, then the operator from the box above, and then the number from the bottom box."))
    (combine 
     ;; + or -
     ("Find two boxes with addition or subtraction that are connected and click them."
      "Click the button labeled \"Combine\""
      "Click the big green box."
      "Enter the signed number from the box above, then the operator from the box below, and then the number from the box below."
      "Click the little green box."
      "Enter the sign from the little box in the box above.")
     ;; * or /
     ("Find two boxes with multiplication or division that are connected and click them."
      "Click the button labeled \"Combine\""
      "Click the big green box."
      "Enter the number from the box above, then the operator from the box below, and then the number from the box below."
      "Click the little green box."
      "Enter the operator from the box below.")
     ;; when there's a - in the bottom box and the number is on the left
     ("Find two boxes with addition or subtraction that are connected and click them."
      "Click the button labeled \"Combine\""
      "Click the big green box."
      "Ether the number from the box below, then the operator from the box below, and then the signed number from the box above."
      "Click the little green box."
      "Enter the opposite of the sign of the little box in the box above.")
     ;; x combine type 1
     ("Find two boxes that multiply the input and click them and the box below that connects them."
      "Click the button labeled \"Combine\""
      "Click the large green box."
      "Enter the number from the top left box, the operator from the bottom box, and the number in the top right box."
      "Click the small green box."
      "Enter *.")
     ;; x combine type 2
     ("Find two boxes that multiply the input and click them both and the two boxes that join them."
      "Click the button labeled \"Combine\""
      "Click the large green box."
      "Enter either the number from the top left box or the negation of it if, in the box below it, the operator is minus and the little black box is on the right; the sign of the little box pointed to by the arrow from the right top box; and the number in the top right box."
      "Click the small green box."
      "Enter *."
      "Click the medium green box."
      "Enter the signed number from the box with plus or minus and then enter +.")
     ;; x combine type 3
     ("Find two boxes with addition and subtraction and click both and the box below that connects them."
      "Click the button labeled \"Combine\""
      "Click the large green box."
      "Enter the signed number from the left box above, +, and the signed number from the right box above."
      "Click the small green box in the middle."
      "Enter the sign of the little box in the left box."
      "Click the bottom small green box."
      "Enter the sign of the little box in the right box.")
     ;; x combine type 2 undo-minus shortcut
     ("THIS SHOULD NEVER HAPPEN"
      "THIS SHOULD NEVER HAPPEN"
      "Click the large green box."
      "Enter the signed number from the left box above, -, and either the number from the right box above or the negation of it if in the box below it the operator is minus and the little black box is on the right."
      "Click the small green box."
      "Enter *."
      "Click the medium green box."
      "Enter - then the signed number from the box with plus or minus.")
     ;; x combine type 3 undo-minus shortcut
     ("THIS SHOULD NEVER HAPPEN"
      "THIS SHOULD NEVER HAPPEN"
      "Click the large green box."
      "Enter the signed number from the left box above, -, and the signed number from the right box above."
      "Click the small green box in the middle."
      "Enter the sign of the little box in the left box."
      "Click the bottom small green box."
      "If the little black box in the right box is on the right and the operator to the left of it is a minus then enter +, otherwise enter -."))
    (reorder
     ;; regular reorder
     (#1="Find a box with addition or subtraction feeding into a box with multiplication and click them."
      #2="Click the button labeled \"Reorder\""
      #3="Click the big green box."
      #4="Enter the number from the box below, then *, and then the number from the box above."
      #5="Click the medium green box."
      #6="Enter the number from the box below and *."
      #7="Click the little green box."
      #8="Enter the operator from the box above.")
     ;; The case when the all number box appears on the left. It's the
     ;; same as above except the hints are in a different order. This
     ;; is because the order that the editables are given to the hint
     ;; system are different depending on which reorder rule matches.
     (#1# #2# #5# #6# #3# #4# #7# #8#))
    (subtract
     ;; regular subtract
     ("Find a box with just a small box and two boxes feeding into it, and click that box."
      "Click the button labeled \"Subtract\""
      "Click the top green box."
      "Enter -."
      "Click the bottom green box."
      "Enter 0."))
    (undo-minus
     ;; a - (x + b) = a - x - b = a + (-b - x)
     ;; a - (b + x) = a - b - x = a + (-b - x)
     ("Find a box with addition or subtraction feeding into a little box that is subtracted and click it as well as the box containing the little box."
      "Click the button labeled \"Undo Minus\""
      "Click the green box above."
      "Enter the opposite of the signed number from the box above and then the opposite of the sign of the little box above."
      "Click the green box below."
      "Enter +.")
     ("Find a box with multiplication feeding into a little box that is subtracted and click it as well as the box containing the little box."
      "Click the button labeled \"Undo Minus\""
      "Click the green box above."
      "Enter the opposite of the number from the box above."
      "Click the green box below."
      "Enter +."))
    (canonicalize
     ("Find a box with addition or subtraction that the input box is feeding into it and click it."
      "Click the button labeled \"Canonicalize\""))
    (shift-addend
     ("Find a + or - box with one number that feeds into a + or - box with no numbers and click them."
      "Click the button labeled \"Shift Addend\""
      "Click this box"
      "Figure it out"
      "Click that box"
      "Attempt the unattemptable"))))

;; (defparameter *angela-instructions*
;;   '((ch1-s1 "Evaluating a diagram involves performing all the operations in the diagram to get a final result.")
;;     (ch1-s2 "Some diagrams to be evaluated have input boxes with just a number that feed into the rest of the diagram.")
;;     (ch1-s7 "Sometimes a diagram contains an input box without a number but at the bottom of the diagram there is a box with the value of the diagram. Then you must invert the diagram to find the value of the input box.")
;;     (ch2-s6 "One can collapse two boxes with + or - into a single box and preserve the value of the diagram. One can do the same thing with two boxes with * or /.")
;;     (ch2-s7 "The invert operation can be repeated." "There is a special case when the operator is - and the little black box is on the right.")
;;     (ch3-s1 "One can transform a diagram so that a + or - box above a * box moves to below a * box and not change the value of the diagram.")
;;     (ch3-s2 "You can also reorder if a - box feeds into a * box." "Before you combine boxes you must switch the operator and the signs in the box above if the little box is subtracted in the box below.")
;;     (ch3-s4 "Sometimes an input box will have more than one arrow connecting it to other boxes. If the boxes connected to it are * boxes, and they are connected to a + or - box, then Combine can be used to simplify the diagram." "Combine works when there is an extra + or - box, too." "If an input box is connected to a + or - box then you need to do an extra step before you can use combine." "When two + or - boxes are connected via a + or - box then they can be combined.")))
