(in-package "TUTOR")

(defun dump-eqn (&optional (b (tutor-eqn-root *tutor*)))
  "Dump the current equation as seen in the transition spreadsheets."
  (let ((dialog-id (if (typep *input-window* 'input-window)
                       (etypecase (input-window-parent *input-window*)
                         (box (box-id (input-window-parent *input-window*)))
                         (argument (arg-id (input-window-parent *input-window*)))))))
    (labels ((dump-box (box)
               (etypecase box
                 ((or symbol number) box)
                 (x-box 'x)
                 (answer-box
                  (format nil "~a~a~a" (openp box) (dump-arg box (answer box)) (closep box)))
                 (number-box
                  (format nil "~a~a~a" (openp box) (dump-arg box (number box)) (closep box)))
                 (arg-box
                  (format nil "~a~a ~a ~a~a"
                          (openp box)
                          (dump-arg box (box-arg1 box))
                          (dump-arg box (box-op box))
                          (dump-arg box (box-arg2 box))
                          (closep box)))))
             (dump-arg (box arg)
               (if (arg-editable arg)
                   (cond ((or (eq dialog-id (arg-id arg))
                              (eq dialog-id (box-id box)))
                          ;; Let'em know what was in the box before
                          (format nil "[F~a]" (if (arg-user-answer arg)
                                                  (format nil " ~a" (arg-user-answer arg))
                                                  "")))
                         ((arg-user-answer arg)
                          (format nil "[~a]" (arg-user-answer arg)))
                         (t "[]"))
                   (dump-eqn (arg-value arg))))
             (openp (box)
               (if (box-selected box) "{" "("))
             (closep (box)
               (if (box-selected box) "}" ")")))
      (dump-box b))))

;; make it easier to call the function
(export 'dump-eqn)
(import 'dump-eqn "TUTOR")
