(require 'quickdraw)

(defpackage :tutor
  (:export #:dump-screen #:execute-command #:next-problem
           #:do-section #:do-problem #:session1 #:session2 #:session3
           #:panel #:prefixify #:render-eqn #:setup-tutor1 #:setup-tutor2
           #:fmri-enable #:fmri-disable #:fmri-session5-part2
           #:fmri-session5-part1 #:fmri-session4-type2 #:fmri-session4
           #:fmri-session3 #:fmri-session2-part2 #:fmri-session2-part1
           #:fmri-session1 #:repos-window #:fmri-panel #:angela-experiment #:angela-session1 #:angela-session2 #:angela-session3 #:reverse-color #:angela-generate-instructions #:customize #:short-tutor #:short-tutor-problems #:select-problem))

(defpackage :calc
  (:export #:calc))

(defun load-file (module)
  (format t "~&Loading ~a...~%" module)
  (if (boundp 'cl-user::tutor-load-format) 
      (load (merge-pathnames (make-pathname :name module :type "lisp") *load-pathname*) :external-format (symbol-value 'cl-user::tutor-load-format))
      (load (merge-pathnames (make-pathname :name module :type "lisp") *load-pathname*))))

(load-file "globals")
(load-file "version")
(load-file "angela-hints")
(load-file "history")
(load-file "fsm")
(load-file "draw")
(load-file "box")
(load-file "box-utils")
(load-file "input")
(load-file "regions")
(load-file "message")
(load-file "eqn-history")
(load-file "graph")
(load-file "operations")
(load-file "calc")
(load-file "problems")
(load-file "text")

(load-file "whatsnext")

(load-file "otto")
(load-file "panel")
(load-file "calc-practice")
(load-file "replay")

;; Arg. If I load replay.lisp function by function MCL doesn't create
;; a replay symbol in cl-user. If I load the whole thing then it
;; does. So, just unbind the replay symbol to avoid conflicts when we
;; import it later.
(unintern 'replay)

;; A cheap hack to detect if act-r is loaded. if it is, load tutor1-device.
(when (fboundp 'common-lisp-user::get-time)
  (load-file "tutor1-device"))

;; import the symbols for convenience
(use-package "TUTOR")
(use-package "REPLAY")
