(clear-all)


(define-model box

(eval `(sgp :esc t :egs 0.1  :ol t :rt -2 :bll .5 :ul nil  :epl nil :lf .00  :v nil
            :model-warnings nil :do-not-harvest imaginal  :do-not-harvest screen 
            :DECLARATIVE-FINST-SPAN 10.0 :DECLARATIVE-NUM-FINSTS 1  
            :ga 0 :ans 1.0 :mp 10 :trace-detail low :alpha .2))

(chunk-type operator pre action arg1 arg2 post episode)
(chunk-type task state step watch arg)
(chunk-type box command val)
(chunk-type verbage command result arg1 arg2)
(chunk-type digital command item)
(chunk-type screen state hint flail success)

(specify-compilation-buffer-type imaginal goal)

(start-up)

(sdp :creation-time -100000000  :references 1000 )

;overall control

(p start-section   =goal>
      isa          task
      step         nil
      state        =state
==>
!safe-bind! =ep (make-episode)
   +imaginal>
      isa operator
      episode =ep
   +DIGITAL>
       ISA DIGITAL
       COMMAND CLICK
       ITEM read  
   =goal>
       step try)

(p read-hint
   =goal>
      isa task
      step try
   =screen>
       isa screen
       state =state
       hint =hint
       success nil
   ?digital>
         state free
==>
  +verbal>
       isa verbage
       command read-hint
       arg1 =state
   =goal>
       step reading-hint)

(p find-operator-post-hint
   =goal>
      isa task
      step reading-hint
      watch nil
   =screen>
       isa screen
       state =state
       hint =hint
   =verbal>
       isa operator
    -  action nil
    =imaginal>
       isa operator
       episode =ep
==>
!safe-eval! (setf *transitions* (append *transitions* (list =state (get-time)) ))
   -verbal>
   =imaginal>
       POST =STATE
   +imaginal>
       ISA OPERATOR
       PRE =STATE
       episode =ep
   +retrieval>
     isa operator
     pre =state
   -  action nil
      :recently-retrieved nil
   =goal>
      step retrieving-operator)

(p find-operator-post-hint1
   =goal>
      isa task
      step reading-hint
      watch nil
   =screen>
       isa screen
       state =state
       hint =hint
   =verbal>
       isa operator
       action nil
    =imaginal>
       isa operator
       episode =ep
==>
!safe-eval! (setf *transitions* (append *transitions* (list =state (get-time)) ))
   =imaginal>
       POST =STATE
   +imaginal>
       ISA OPERATOR
       PRE =STATE
       episode =ep
   +retrieval>
     isa operator
     pre =state
      episode nil
   -  action nil
      :recently-retrieved nil
   =goal>
      step retrieving-operator)

(p find-operator-post-hint2
   =goal>
      isa task
      step reading-hint
      watch =val
   =screen>
       isa screen
       state =state
       hint =hint
   =verbal>
       isa operator
    =imaginal>
       isa operator
       episode =ep
==>
!safe-eval! (setf *transitions* (append *transitions* (list =state (get-time)) ))
   =imaginal>
       POST =STATE
   +imaginal>
       ISA OPERATOR
       PRE =STATE
       episode =ep
   +retrieval>
     isa operator
     pre =state
      episode nil
   -  action nil
   - action =val
      :recently-retrieved nil
   =goal>
      step retrieving-operator)



(p find-operator
   =goal>
      isa task
      step try
   =screen>
       isa screen
       state =state
       success nil
       hint nil
   ?digital>
         state free
    =imaginal>
       isa operator
       episode =ep
==>
!safe-eval! (setf *transitions* (append *transitions* (list =state (get-time)) ))
   =imaginal>
       POST =STATE
   +imaginal>
       ISA OPERATOR
       PRE =STATE
       episode =ep
   +retrieval>
     isa operator
     pre =state
      episode nil
   -  action nil
      :recently-retrieved nil
   =goal>
      step retrieving-operator)


(p find-operator-again
   =goal>
      isa task
      step retrieving-operator
   =screen>
       isa screen
       state =state
       success nil
   ?retrieval>
       state error
==>
   +retrieval>
     isa operator
     pre =state
      episode nil
   -  action nil
      :recently-retrieved nil)

(p find-operator-again1
   =goal>
      isa task
      step retrieving-operator
      watch =watch
   =screen>
       isa screen
       state =state
       success nil
   =retrieval>
       isa operator
       action =watch
==>
   +retrieval>
     isa operator
     pre =state
      episode nil
   -  action nil
      :recently-retrieved nil)

(P do-click-box
   =GOAL>
       ISA TASK
       STEP retrieving-operator
   =retrieval>
       isa operator
       action =action
    =imaginal>
       isa operator
!safe-eval! (box-action =action)
 ==>
!safe-eval! (record-it  =action)
   =imaginal>
       ACTION =action
   +graphical>
     isa box
     command =action
   =GOAL>
       STEP do-box)

(P do-next
   =GOAL>
       ISA TASK
       STEP retrieving-operator
   =retrieval>
       isa operator
       action next
    =imaginal>
       isa operator
   =screen>
       isa screen
       state =state
!safe-eval! (finished =state)
 ==>
!safe-eval! (record-it 'Next)
!safe-eval! (setf *transitions* (append *transitions* (list 'done (get-time)) ))
   =imaginal>
       ACTION next
   +DIGITAL>
       ISA DIGITAL
       COMMAND CLICK
       ITEM next
   =GOAL>
       STEP TRY
)

(P do-next1
   =GOAL>
       ISA TASK
       STEP retrieving-operator
   =retrieval>
       isa operator
       action next
    =imaginal>
       isa operator
   =screen>
       isa screen
       state =state
!safe-eval! (not (finished =state))
 ==>
!safe-eval! (record-it 'Next)
   =imaginal>
       ACTION next
   +DIGITAL>
       ISA DIGITAL
       COMMAND CLICK
       ITEM next
   =GOAL>
       STEP TRY
)

(p click-box
   =goal>
      isa task
      step do-box
   =graphical> 
      isa box
      val =var
   ==>
   +digital>
     isa digital
     command click
     item =var
   =goal>
      step try)

(p do-box-error
   =goal>
      isa task
      step do-box
   =graphical> 
      isa box
      val nil
   ==>
   =goal>
      step try)

(P do-click-button
   =GOAL>
       ISA TASK
       STEP RETRIEVING-OPERATOR
   =retrieval>
       isa operator
       action =action
    =imaginal>
       isa operator
!safe-eval! (button-action =action)
 ==>
!safe-eval! (record-it  =action)
   =imaginal>
       ACTION =action
   +digital>
     isa digital
     command click
     item =action
   =goal>
      step try)

(P first-mistake
   =GOAL>
       ISA TASK
       STEP RETRIEVING-OPERATOR
   =SCREEN>
       ISA SCREEN
       STATE =STATE
   =retrieval>
       isa operator
       action first-mistake
    =imaginal>
       isa operator
 ==>
!SAFE-BIND! =EP (MAKE-EPISODE)
!bind! =bad (find-mistake)
;!eval! (print 'mistake)
   =SCREEN>
       SUCCESS NIL
   +IMAGINAL>
       ISA OPERATOR
       PRE =STATE
       EPISODE =EP
   +digital>
     isa digital
     command click
     item first-mistake
   =goal>
      step try
     watch =bad)

(spp first-mistake :at 60)


(P do-type-number
   =GOAL>
       ISA TASK
       STEP retrieving-operator
     - watch =action
    =retrieval>
      isa operator
      ACTION  =action
    =imaginal>
       isa operator
!safe-eval! (number-action =action)
 ==>
!safe-eval! (record-it  =action)
   =imaginal>
       ACTION =action
   +graphical>
     isa box
     command =action
   =GOAL>
       STEP do-math
       arg =action
)

(P do-burp
   =GOAL>
       ISA TASK
       STEP retrieving-operator
    =retrieval>
      isa operator
      ACTION  burp
 ==>
!safe-eval! (record-it  'burp)
   +digital>
     isa digital
     command enter
     item ""
   =goal>
      step try)

(P type-string
   =GOAL>
       ISA TASK
       STEP retrieving-operator
    =retrieval>
      isa operator
      ACTION  type
      arg1 =val
 ==>
!safe-eval! (record-it  'type)
   +digital>
     isa digital
     command enter
     item =val
   =goal>
      step try)

(p evaluate-box
   =goal>
      isa     task
      step    do-math
      arg =action
   =graphical> 
      isa box
      val =val
   ==>
   =goal>
      step    do-number
   +mathematical>
      isa     verbage 
      command evaluate-box
      arg1    =val
      arg2    =action)

(p skip-evaluate-box
   =goal>
      isa     task
      step    do-math
   =graphical> 
      isa box
      val nil
   ==>
   =goal>
      step try)

(p type
   =goal>
      isa task
      step do-number
    =mathematical>
       isa verbage
       result =val1
   ==>
   +digital>
     isa digital
     command enter
     item =val1
   =goal>
      step try)

(p skip-type
   =goal>
      isa task
      step do-number
    =mathematical>
       isa verbage
       result nil
   ==>
   =goal>
      step try)

(p detect-success
   =GOAL>
       ISA TASK
       STEP try
   =screen>
       isa screen
       state =state
       flail t
       success t
   =imaginal>
       isa operator
       pre =pre
       episode =ep
!safe-eval! (not (terminus =pre))
 ==>
!safe-eval! (setf *transitions* (append *transitions* (list nil (get-time)) ))
   =imaginal>
       post nil
       episode nil
    =screen>
       success nil
   +retrieval>
      isa operator
    - pre =pre
      post =pre
      episode =ep
   =GOAL>
       STEP reflect)

;(spp detect-success :reward 50)

(p detect-success-done
   =GOAL>
       ISA TASK
       STEP try
   =screen>
       isa screen
       state =state
       flail t
       success t
   =imaginal>
       isa operator
       pre =pre
       episode =ep
!safe-eval! (terminus =pre)
 ==>
!safe-eval! (setf *transitions* (append *transitions* (list nil (get-time)) ))
!safe-bind! =new (make-episode)
   =imaginal>
       post nil
       episode nil
    =screen>
       success nil
   +imaginal>
       isa operator
       pre =state
       episode =new)

;(spp detect-success-done :reward 50)

(p simple-success
   =GOAL>
       ISA TASK
       STEP try
   =screen>
       isa screen
       state =state
       flail nil
       success t
   ?digital>
         state free
 ==>
!safe-eval! (setf *transitions* (append *transitions* (list nil (get-time)) ))
!safe-bind! =ep (make-episode)
   =screen>
      success nil
   +imaginal>
       isa operator
       pre =state
       episode =ep)

;(spp simple-success :reward 50)


(p propogate-success
   =GOAL>
       ISA TASK
       STEP reflect
   =retrieval>
       isa operator
       pre =pre
       post =post
       episode =ep
!safe-eval! (not (terminus =pre))
!safe-eval! (good-state =pre =post)
 ==>
   =retrieval>
       episode nil
       post nil
   +retrieval>
      isa operator
    - pre =pre
    - pre =post
      post =pre
      episode =ep
   -  action nil
      :recently-retrieved nil)

(p propogate-success-done
   =GOAL>
       ISA TASK
       STEP reflect
   =retrieval>
       isa operator
       pre =pre
       post =post
       episode =ep
   =screen>
       isa screen
       state =state
!safe-eval! (terminus =pre)      
!safe-eval! (good-state =pre =post)
 ==>
!safe-bind! =ep (make-episode)
   +imaginal>
       isa operator
       pre =state
       episode =ep
   =retrieval>
       episode nil
       post nil
   =goal>
      step try)

(p move-on1
   =GOAL>
       ISA TASK
       STEP reflect
   =screen>
       isa screen
       state =state
   ?retrieval>
       state error
 ==>
!safe-bind! =ep (make-episode)
   +imaginal>
       isa operator
       pre =state
       episode =ep
   =goal>
      step try)


(p move-on2
   =GOAL>
       ISA TASK
       STEP reflect
   =screen>
       isa screen
       state =state
   =retrieval>
       isa operator
       pre =pre
       post =post
       episode =ep
!safe-eval! (not (good-state =pre =post))
 ==>
!safe-bind! =ep (make-episode)
   +imaginal>
       isa operator
       pre =state
       episode =ep
   =goal>
      step try)

(p move-on3
   =GOAL>
       ISA TASK
       STEP reflect
   =screen>
       isa screen
       state =state
   =retrieval>
       isa operator
       pre nil
 ==>
!safe-bind! =ep (make-episode)
   +imaginal>
       isa operator
       pre =state
       episode =ep
   =goal>
      step try)

(spp :u 50)
)







